<template>
  <view class="components-video-player">
    <view
      ref="videoRef"
      class="video-js"
      :style="{width: sysInfo.windowWidth +'px', height: sysInfo.windowHeight + 'px'}"
    />
  </view>
</template>

<script setup>
import 'videojs-flvjs-es6'
import videojs from 'video.js'
import 'video.js/dist/video-js.min.css'
import videoZhCN from 'video.js/dist/lang/zh-CN.json'
videojs.addLanguage('zh-CN', videoZhCN)

const emit = defineEmits(['play'])
let videoPlayer = null // 播放器实例
let isPlaying = false // 是否正在播放
const sysInfo = ref({}) // 设备信息
let timer = null // 定时器
const videoRef = ref(null)
const initVideo = (src) => {
  const videoId = 'video' + new Date().getTime()
  const video = document.createElement('video')
  video.id = videoId
  // 如果需要全屏幕展现播放器需要增加 object-fit: cover;
  video.style = `width: ${sysInfo.value.windowWidth}px; height: ${sysInfo.value.windowHeight}px;`
  video.controls = false
  video.setAttribute('playsinline', false) // IOS微信浏览器支持小窗内播放
  video.setAttribute('webkit-playsinline', false) // 这个bai属性是ios 10中设置可以让视频在小du窗内播放，也就是不是全屏播放的video标签的一个属性
  video.setAttribute('x5-video-player-type', 'h5') // 安卓 声明启用同层H5播放器 可以在video上面加东西
  const source = document.createElement('source')
  source.src = src // 设定的流地址
  // 根据流地址的后缀设置好播放类型
  if (source.src.indexOf('.mp4') !== -1) {
    // mp4类型
    source.type = 'video/mp4'
  } else if (source.src.indexOf('.m3u8') !== -1) {
    // hls类型
    source.type = 'application/x-mpegURL'
  } else if (source.src.indexOf('.flv') !== -1) {
    // flv类型
    source.type = 'video/x-flv'
  } else {
    // rtmp类型
    source.type = 'rtmp/hls'
  }
  // 将播放源添加到video的子级
  video.appendChild(source)
  // 挂载到视频容器中
  videoRef.value.$el.appendChild(video)
  // 获取屏幕宽高计算出需要展现的比例
  // 如果是竖屏模式，动态计算出设备宽高，设定一个比例
  const aspectRatio = sysInfo.value.windowWidth + ':' + sysInfo.value.windowHeight

  videoPlayer = videojs(
    videoId,
    {
      // poster: ‘视频封面图, //视频封面图
      // title: '视频标题', //视频标题
      width: sysInfo.value.windowWidth,
      height: sysInfo.value.windowHeight,
      playbackRates: [0.7, 1.0, 1.5, 2.0], // 播放速度
      autoDisable: true,
      preload: 'none', // auto - 当页面加载后载入整个视频 meta - 当页面加载后只载入元数据 none - 当页面加载后不载入视频
      language: 'zh-CN',
      fluid: true, // 自适应宽高
      muted: false, //  是否静音
      aspectRatio, // 将播放器置于流畅模式，并在计算播放器的动态大小时使用该值。值应该代表一个比例 - 用冒号分隔的两个数字（例如"16:9"或"4:3"）
      controls: false, // 是否拥有控制条 【默认true】,如果设为false ,那么只能通过api进行控制了。也就是说界面上不会出现任何控制按钮
      autoplay: true, // 如果true,浏览器准备好时开始回放。 autoplay: "muted", // //自动播放属性,muted:静音播放
      loop: true, // 导致视频一结束就重新开始。 视频播放结束后，是否循环播放
      // techOrder: ['html5', 'flash'], // 播放顺序
      screenshot: true,
      controlBar: {
        volumePanel: {
          // 声音样式
          inline: false // 不使用水平方式
        },
        timeDivider: true, // 时间分割线
        durationDisplay: true, // 总时间
        progressControl: true, // 进度条
        remainingTimeDisplay: true, // 当前以播放时间
        fullscreenToggle: true, // 全屏按钮
        pictureInPictureToggle: true // 画中画
      }
    },
    function () {
      this.on('error', function () {
        // 请求数据时遇到错误
        disposeVideo()
        timer = setTimeout(() => {
          initVideo(src)
        }, 2000)
      })
      this.on('stalled', function () {
        // 网速失速
        // console.log('网速失速')
      })
      this.on('play', function () {
        // 开始播放
        // eslint-disable-next-line no-console
        console.log('开始播放')
        clearTimeout(timer)
        emit('play')
        isPlaying = true
      })
      this.on('pause', function () {
        // 暂停
        // eslint-disable-next-line no-console
        console.log('暂停')
        isPlaying = false
      })
      this.on('timeupdate', function () { })
    }
  )
}
// 销毁播放器
const disposeVideo = () => {
  if (videoPlayer) {
    videoPlayer.dispose()
  }
}
// 播放视频
const playVideo = () => {
  if (!isPlaying) {
    videoPlayer.play()
  }
}
// 暂停播放视频
const pauseVideo = () => {
  videoPlayer.pause()
}

onMounted(() => {
  sysInfo.value = uni.getSystemInfoSync()
})
onUnmounted(() => {
  if (videoPlayer) {
    disposeVideo()
  }
})

defineExpose({
  initVideo,
  playVideo,
  pauseVideo
})
</script>

<style lang="scss" scoped>
.components-video-player {
  position: relative;
  display: flex;
  justify-content: center;
  align-items: center;
}
</style>
